<?xml version="1.0" encoding="UTF-8"?>
<schema fpi="http://schemas.opengis.net/timeseriesml/1.0/xsd-measurement-timeseries-tvp.sch" see="http://www.opengis.net/spec/timeseriesml/1.0/req/xsd-measurement-timeseries-tvp"
  xmlns="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       This document is under construction and has not yet been tested.
       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -->

  <!--
    This Schematron schema checks the timeseries and points within the series are 
    all consistent with the interleaved measurement timeseries requirements class. 
    
    OGC TimeseriesML 1.0 is an OGC Standard.
    Copyright (c) 2015 Open Geospatial Consortium.
    To obtain additional rights of use, visit http://www.opengeospatial.org/legal/ .

    version="1.0.0"
  -->
  
  <title>OGC TimeseriesML 1.0 measurement time series validation</title>
  <p>Verifies the timeseries is valid according the measure time series class, http://www.opengis.net/spec/timeseriesml/1.0/req/xsd-measurement-timeseries-tvp</p>
  <ns prefix="tsml" uri="http://www.opengis.net/timeseriesml/1.0"/>
  <ns prefix="om" uri="http://www.opengis.net/om/2.0"/>
  <ns prefix="gml" uri="http://www.opengis.net/gml/3.2"/>
  <ns prefix="xsi" uri="http://www.w3.org/2001/XMLSchema-instance"/>
  <ns prefix="xlink" uri="http://www.w3.org/1999/xlink"/>
  
  <xsl:import-schema schema-location="http://schemas.opengis.net/timeseriesml/1.0/timeseriesML.xsd" namespace="http://www.opengis.net/timeseriesml/1.0"/>
  
  <xsl:import-schema schema-location="http://schemas.opengis.net/gml/3.2.1/gml.xsd" namespace="http://www.opengis.net/gml/3.2"/>
  
  <pattern id="interpolation-type">
    <title>Test requirement: /req/xsd-measurement-timeseries-tvp/interpolation-type</title>
    <rule context="//tsml:MeasurementTimeseries/tsml:point/tsml:Measurement">
      <assert test="tsml:metadata/tsml:TVPMeasurementMetadata/tsml:interpolationType or 
        ../../tsml:defaultPointMetadata/tsml:DefaultTVPMeasurementMetadata/tsml:interpolationType">
        The interpolation type of a point must be set explicitly or through the default point metadata.  
      </assert>
    </rule>
  </pattern>
  
  <pattern id="value-measure">
    <title>Test requirement: /req/xsd-measurement-timeseries-tvp/value-measure</title>
    <rule context="//tsml:MeasurementTimeseries/tsml:point"> 
      <assert test="schema-element(tsml:Measurement)">The time series points must be of type measurement</assert>
    </rule>
  </pattern>
  
  <pattern id="unit-of-measure">
    <title>Test requirement: /req/xsd-measurement-timeseries-tvp/unit-of-measure</title>
    <rule context="//tsml:point/tsml:Measurement/tsml:value"> 
      <assert test="@code or ../../../tsml:defaultPointMetadata/tsml:DefaultTVPMeasurementMetadata/tsml:uom[@code]">A unit of measure
        must be supplied either through the default point metadata or by explicit attribute on the value.</assert>
    </rule>
  </pattern>
  
</schema>
